package app;

import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;

import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.awt.GLCanvas;
import com.jogamp.opengl.awt.GLJPanel;
import com.jogamp.opengl.util.FPSAnimator;

import gui.DataForm;
import model.Renderer;

public class App {
	private static final int FPS = 60;
	public static int width = 1200;
	public static int height = 650;

	public static void main(String[] args) {
		try {
			JFrame testFrame = new JFrame("3DGraphExplorer");

			testFrame.setExtendedState(JFrame.MAXIMIZED_BOTH); 
//			testFrame.setLayout(new FlowLayout());
			testFrame.setLayout(new GridLayout(1,1));
			// setup OpenGL Version 2
			GLProfile profile = GLProfile.get(GLProfile.GL2);
			GLCapabilities capabilities = new GLCapabilities(profile);
			capabilities.setRedBits(8);
			capabilities.setBlueBits(8);
			capabilities.setGreenBits(8);
			capabilities.setAlphaBits(8);
			capabilities.setDepthBits(24);

			// The canvas is the widget that's drawn in the JFrame
			GLCanvas canvas = new GLCanvas(capabilities);
			Renderer ren = new Renderer();
			canvas.addGLEventListener(ren);
			canvas.addMouseListener(ren);
			canvas.addMouseMotionListener(ren);
			canvas.addKeyListener(ren);
			canvas.setSize(650,650);
			
			DataForm dataForm = new DataForm();
			JPanel panel = new JPanel();
			panel.add(dataForm);		
			panel.setSize(650,650);

			GLJPanel p1 = new GLJPanel();
			JPanel p2 = new JPanel();
			
			p1.add(canvas);
			p2.add(panel);

			testFrame.add(p1);
			testFrame.add(p2);

			final FPSAnimator animator = new FPSAnimator(canvas, FPS, true);

			testFrame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					new Thread() {
						@Override
						public void run() {
							if (animator.isStarted())
								animator.stop();
							System.exit(0);
						}
					}.start();
				}
			});
			// testFrame.setTitle("");
			testFrame.pack();
			testFrame.setVisible(true);
			animator.start(); // start the animation loop

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}