package model;

import com.jogamp.opengl.GL2;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.glu.GLU;
import com.jogamp.opengl.util.gl2.GLUT;
import com.jogamp.opengl.util.texture.Texture;
import com.jogamp.opengl.util.texture.TextureIO;
import gui.DataForm;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;
import java.awt.event.KeyListener;
import java.awt.Color;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.IOException;
import java.nio.FloatBuffer;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;

public class Renderer implements GLEventListener, MouseListener, MouseMotionListener, KeyListener {

	GLU glu;
	GLUT glut;

	int width, height, dx, dy, x, y;
	int ox, oy;

	float zenit;
	float azimut;

	double ex, ey, ez, px = 450, py = 200, pz = 3200, cenx, ceny, cenz, ux, uy, uz;
	int layout = 0;

	float step, rot = 0, trans = 0;
	double a_rad, z_rad;
	long oldmils = System.currentTimeMillis();

	public static File file1, file2, file3, file4, file5, file6;
	public static Texture texture1, texture2, texture3, texture4, texture5, texture6;
	float m[] = new float[16];
	float m1[] = new float[16];

	List<Node> nodes = new ArrayList<Node>();
	List<Edge> edges = new ArrayList<Edge>();

	int mouse_x, mouse_y;
	List<Color> colors = new ArrayList<Color>();
	boolean selecting = false;

	FRLayout frl = new FRLayout();
	int ix = 0;

	@Override
	public void init(GLAutoDrawable glDrawable) {
		GL2 gl = glDrawable.getGL().getGL2();
		glu = new GLU();
		glut = new GLUT();

		gl.glEnable(GL2.GL_DEPTH_TEST);
		gl.glPolygonMode(GL2.GL_FRONT, GL2.GL_FILL);
		gl.glPolygonMode(GL2.GL_BACK, GL2.GL_FILL);

		file1 = new File("./img/skybox_left.tga");
		file2 = new File("./img/skybox_down.tga");
		file3 = new File("./img/skybox_right.tga");
		file4 = new File("./img/skybox_front.tga");
		file5 = new File("./img/skybox_back.tga");
		file6 = new File("./img/skybox_up.tga");

		try {
			texture1 = TextureIO.newTexture(file1, true);
			texture2 = TextureIO.newTexture(file2, true);
			texture3 = TextureIO.newTexture(file3, true);
			texture4 = TextureIO.newTexture(file4, true);
			texture5 = TextureIO.newTexture(file5, true);
			texture6 = TextureIO.newTexture(file6, true);
		} catch (IOException e) {
			System.err.println("Chyba cteni souboru s texturou");
		}

		// init display settings
		zenit -= dy;
		if (zenit > 90)
			zenit = 90;
		if (zenit <= -90)
			zenit = -90;
		azimut += dx;
		azimut = azimut % 360;
		a_rad = azimut * Math.PI / 180;
		z_rad = zenit * Math.PI / 180;
		ex = Math.sin(a_rad) * Math.cos(z_rad);
		ey = Math.sin(z_rad);
		ez = -Math.cos(a_rad) * Math.cos(z_rad);
		ux = Math.sin(a_rad) * Math.cos(z_rad + Math.PI / 2);
		uy = Math.sin(z_rad + Math.PI / 2);
		uz = -Math.cos(a_rad) * Math.cos(z_rad + Math.PI / 2);

		// Display Lists
		gl.glNewList(1, gl.GL_COMPILE);
		gl.glColor3d(0.5, 0.5, 0.5);

		gl.glEnable(GL2.GL_TEXTURE_2D);
		gl.glTexEnvi(GL2.GL_TEXTURE_ENV, GL2.GL_TEXTURE_ENV_MODE, GL2.GL_CLAMP);

		// front
		Renderer.texture4.bind(gl);
		final float skySize = 5000;
		gl.glBegin(GL2.GL_QUADS);
		gl.glTexCoord2f(0, 0);
		gl.glVertex3f(skySize, -skySize, -skySize);
		gl.glTexCoord2f(1, 0);
		gl.glVertex3f(-skySize, -skySize, -skySize);
		gl.glTexCoord2f(1, 1);
		gl.glVertex3f(-skySize, skySize, -skySize);
		gl.glTexCoord2f(0, 1);
		gl.glVertex3f(skySize, skySize, -skySize);
		gl.glEnd();

		// right
		Renderer.texture3.bind(gl);
		gl.glBegin(GL2.GL_QUADS);
		gl.glTexCoord2f(0, 0);
		gl.glVertex3f(skySize, -skySize, skySize);
		gl.glTexCoord2f(1, 0);
		gl.glVertex3f(skySize, -skySize, -skySize);
		gl.glTexCoord2f(1, 1);
		gl.glVertex3f(skySize, skySize, -skySize);
		gl.glTexCoord2f(0, 1);
		gl.glVertex3f(skySize, skySize, skySize);
		gl.glEnd();

		// back
		Renderer.texture5.bind(gl);
		gl.glBegin(GL2.GL_QUADS);
		gl.glTexCoord2f(0, 0);
		gl.glVertex3f(-skySize, -skySize, skySize);
		gl.glTexCoord2f(1, 0);
		gl.glVertex3f(skySize, -skySize, skySize);
		gl.glTexCoord2f(1, 1);
		gl.glVertex3f(skySize, skySize, skySize);
		gl.glTexCoord2f(0, 1);
		gl.glVertex3f(-skySize, skySize, skySize);
		gl.glEnd();

		// left
		Renderer.texture1.bind(gl);
		gl.glBegin(gl.GL_QUADS);
		gl.glTexCoord2f(0, 0);
		gl.glVertex3f(-skySize, -skySize, -skySize);
		gl.glTexCoord2f(1, 0);
		gl.glVertex3f(-skySize, -skySize, skySize);
		gl.glTexCoord2f(1, 1);
		gl.glVertex3f(-skySize, skySize, skySize);
		gl.glTexCoord2f(0, 1);
		gl.glVertex3f(-skySize, skySize, -skySize);
		gl.glEnd();

		// top
		Renderer.texture6.bind(gl);
		gl.glBegin(gl.GL_QUADS);
		gl.glTexCoord2f(1, 1);
		gl.glVertex3f(-skySize, skySize, -skySize);
		gl.glTexCoord2f(0, 1);
		gl.glVertex3f(-skySize, skySize, skySize);
		gl.glTexCoord2f(0, 0);
		gl.glVertex3f(skySize, skySize, skySize);
		gl.glTexCoord2f(1, 0);
		gl.glVertex3f(skySize, skySize, -skySize);
		gl.glEnd();

		// bottom
		Renderer.texture2.bind(gl);
		gl.glBegin(GL2.GL_QUADS);
		gl.glTexCoord2f(1, 0);
		gl.glVertex3f(skySize, -skySize, -skySize);
		gl.glTexCoord2f(1, 1);
		gl.glVertex3f(skySize, -skySize, skySize);
		gl.glTexCoord2f(0, 1);
		gl.glVertex3f(-skySize, -skySize, skySize);
		gl.glTexCoord2f(0, 0);
		gl.glVertex3f(-skySize, -skySize, -skySize);
		gl.glEnd();

		gl.glDisable(GL2.GL_TEXTURE_2D);
		gl.glEndList();

		gl.glNewList(2, gl.GL_COMPILE);
		glut.glutSolidSphere(5, 10, 10);
		gl.glEndList();

		// float a = 0f;

		for (float r = 0; r < 1; r++) {
			for (float g = 0; g < 1; g++) {
				for (float b = 0; b < 1; b += 0.005f) {
					for (float a = 0; a < 1; a += 0.005f) {
						colors.add(new Color(r, g, b, a));
					}
				}
			}
		}
	}

	@Override
	public void display(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();
		drawSetup(gl);
		drawScene(gl);

		frl.iteration(DataForm.graph, DataForm.graph.nodes.size()*2);		

		if (selecting) {
			Color index;
			FloatBuffer pixels = FloatBuffer.allocate(4);
			int[] viewport = new int[4];

			gl.glGetIntegerv(GL2.GL_VIEWPORT, viewport, 0);

			gl.glReadBuffer(GL2.GL_BACK);
			gl.glReadPixels(mouse_x, viewport[3] - mouse_y, 1, 1, GL2.GL_RGBA, GL2.GL_FLOAT, pixels);

			index = new Color(pixels.get(0), pixels.get(1), pixels.get(2), pixels.get(3));
			try {
				Node n = Node.getNodeByColor(index.getRGB(), nodes);
				for (Node node1 : nodes) {
					node1.isSelected = false;
				}
				for (Edge edge1 : edges) {
					edge1.isSelected = false;
				}
				if (n != null) {
					n.setIsSelected(true);
				}
				List<Edge> tmpEdges = Edge.getEdgesByNode(n, edges);
				for (Edge edge : tmpEdges) {
					edge.setIsSelected(true);
				}

				DataForm.table.changeSelection(n.id - 1, 1, false, false);
			} catch (Exception e) {
			}
			selecting = false;
		}
	}

	public void drawVertices(GL2 gl) {
		nodes = DataForm.nodes;
		for (int i = 0; i < nodes.size(); i++) {
			gl.glPushMatrix();
			gl.glTranslated(nodes.get(i).px, nodes.get(i).py, nodes.get(i).pz);

			if (nodes.get(i).isSelected == true) {
				gl.glColor4f(1, 0, 0, 1);
			} else {
				nodes.get(i).setColor(colors.get(i));
				gl.glColor4f((float) nodes.get(i).getColor().getRed() / 255,
						(float) nodes.get(i).getColor().getGreen() / 255,
						(float) nodes.get(i).getColor().getBlue() / 255,
						(float) nodes.get(i).getColor().getAlpha() / 255);
			}
			gl.glCallList(2);
			gl.glPopMatrix();
			gl.glFlush();
		}
	}

	public void drawEdges(GL2 gl) {
		edges = DataForm.edges;
		for (int i = 0; i < edges.size(); i++) {
			if (edges.get(i).isSelected == true) {
				gl.glColor3d(1, 0, 0);
			} else {
				gl.glColor3d(0, 0.46, 0.73);
			}
			gl.glBegin(GL2.GL_LINES);
			gl.glVertex3d(edges.get(i).getSource().px, edges.get(i).getSource().py, edges.get(i).getSource().pz);
			gl.glVertex3d(edges.get(i).getTarget().px, edges.get(i).getTarget().py, edges.get(i).getTarget().pz);
			gl.glEnd();
		}
	}

	public void drawSetup(GL2 gl2) {
		GL2 gl = gl2.getGL().getGL2();
		long mils = System.currentTimeMillis();
		step = (mils - oldmils) / 1000.0f;
		oldmils = mils;
		trans = 1000 * step;
		rot += 360 * step / 10f;

		// vymazani obrazovky a Z-bufferu
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);

		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();

		// perspektivni projekce
		glu.gluPerspective(45, width / (float) height, 0.1f, 10000.0f);

		gl.glMatrixMode(GL2.GL_MODELVIEW);

		// transformace pro sky box
		gl.glPushMatrix();

		gl.glLoadIdentity();
		glu.gluLookAt(0, 0, 0, ex, ey, ez, ux, uy, uz);

		// draw skybox
		gl.glCallList(1);
		gl.glPopMatrix();

		// transformace sceny
		gl.glLoadIdentity();
		glu.gluLookAt(px, py, pz, ex + px, ey + py, ez + pz, ux, uy, uz);
	}

	public void drawScene(GL2 gl2) {
		GL2 gl = gl2.getGL().getGL2();
		drawVertices(gl);
		drawEdges(gl);
	}

	public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
		this.width = width;
		this.height = height;
		GL2 gl = drawable.getGL().getGL2();
		gl.glViewport(0, 0, width, height);
		drawSetup(gl);
	}

	@Override
	public void mouseClicked(MouseEvent e) {
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mousePressed(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON3) {
			mouse_x = e.getX();
			mouse_y = e.getY();
			selecting = true;
		}
		ox = e.getX();
		oy = e.getY();
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON1) {
		}
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		dx = e.getX() - ox;
		dy = e.getY() - oy;

		ox = e.getX();
		oy = e.getY();

		zenit -= dy;
		if (zenit > 90)
			zenit = 90;
		if (zenit <= -90)
			zenit = -90;
		azimut += dx;
		azimut = azimut % 360;
		a_rad = azimut * Math.PI / 180;
		z_rad = zenit * Math.PI / 180;
		ex = Math.sin(a_rad) * Math.cos(z_rad);
		ey = Math.sin(z_rad);
		ez = -Math.cos(a_rad) * Math.cos(z_rad);
		ux = Math.sin(a_rad) * Math.cos(z_rad + Math.PI / 2);
		uy = Math.sin(z_rad + Math.PI / 2);
		uz = -Math.cos(a_rad) * Math.cos(z_rad + Math.PI / 2);
	}

	@Override
	public void mouseMoved(MouseEvent e) {

	}

	@Override
	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_R) {
			px = 450;
			py = 200;
			pz = 3200;		}
		if (e.getKeyCode() == KeyEvent.VK_N) {
			JOptionPane.showMessageDialog(null, "WASD - pohyb \n" + "Ltl. my - rozhlen \n"
					+ "Rtl. my - vbr vrcholu ve scn \n" + "R - reset pozice \n" + "N - npovda \n");
		}
		if (e.getKeyCode() == KeyEvent.VK_W) {
			px += ex * trans;
			py += ey * trans;
			pz += ez * trans;
		}
		if (e.getKeyCode() == KeyEvent.VK_S) {
			px -= ex * trans;
			py -= ey * trans;
			pz -= ez * trans;
		}
		if (e.getKeyCode() == KeyEvent.VK_A) {
			pz -= Math.cos(a_rad - Math.PI / 2) * trans;
			px += Math.sin(a_rad - Math.PI / 2) * trans;
		}
		if (e.getKeyCode() == KeyEvent.VK_D) {
			pz += Math.cos(a_rad - Math.PI / 2) * trans;
			px -= Math.sin(a_rad - Math.PI / 2) * trans;
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {

	}

	@Override
	public void keyTyped(KeyEvent e) {
	}

	@Override
	public void dispose(GLAutoDrawable drawable) {
	}
}